_G[gTable] = {};

local aTmpVal   = gTable;
cm.SetupTable(_G[aTmpVal]);


-- Called on Init
_G[gTable].OnInit = function(pObj)
	pObj.mState = 0;
end


-- Called after data being loaded from disk
_G[gTable].OnLoad = function(pObj)

end


-- Called on a update
_G[gTable].OnUpdate = function(pObj)

end


-- Called on a succesful click
_G[gTable].OnClick =  function(pObj, pName, pActorObj, pPolyNum, pX, pY)

	pObj.mDiscovered = true;
	if pName == "" then
      cm.GetShowInfo(pObj, "InfoStr1", "InfoTime1");
      return true;

	elseif pName == pObj.mCsData:GetString("KeyObject") then

		if pObj.mState == 0 then

         -- Update object state
			pObj.mState		= pObj.mState + 1;
			pObj.mCurCell	= pObj.mCurCell + 1;
			cm.DisableObject(pObj);

         -- Update game flags
   		local aFlagName = pObj.mCsData:GetString("SetFlag1");
   		local aCounter  = 0;
   		if pObj.mPdata.mCsData:IfExistsInt(aFlagName) then
            aCounter = pObj.mPdata.mCsData:GetInt(aFlagName);
         end
         aCounter = aCounter + 1;
   		pObj.mPdata.mCsData:SetVal(aFlagName, aCounter);

			_G[pActorObj.mScriptTag].OnUse(pActorObj, pObj);
			return true;
      end

		cm.ObjDoesNotWork(pObj);
		return false;

	else
		cm.ObjDoesNotWork(pObj);
		return false;
	end

   return false;

end



-- Called on draw
_G[gTable].OnDraw =  function(pObj, pG)
	pG:PushState();

	local aRpos = pObj.mSmPos;
	local aImg  = IcImageWrap(pObj.mSmallImage);
	assert(aImg);
	local aRect = aImg:GetCelRect(pObj.mCurCell);
	pG:DrawImage(aImg:GetImage(), aRpos.x, aRpos.y, aRect);

	pG:PopState();
end



-- Called on moused
_G[gTable].OnMoused =  function(pObj)

end

-- Called on Unmoused
_G[gTable].OnUnMoused =  function(pObj)

end


